package Injection;

import java.util.ArrayList;

import beans.metamodel.details;
import beans.metamodel.eAnnotation;
import beans.metamodel.eClassifier;
import beans.metamodel.eLiteral;
import beans.metamodel.eStructuralFeature;

public class MappingIstarConfig {
	
	public MappingIstarConfig(){
		
	}
	
	public void selectCompartmentPredefined(String name){
		eLiteral newLiteral = new eLiteral();
		newLiteral.setName(name.toUpperCase());
		int value = ParserXML_Metamodel.getEnumCompartmentType().getELiteral().size();
		newLiteral.setValue(String.valueOf(value));
		
		ParserXML_Metamodel.getEnumCompartmentType().getELiteral().add(newLiteral);
		
	}
	
	public void selectElementPredefined(String name){
		eLiteral newLiteral = new eLiteral();
		newLiteral.setName(name.toUpperCase());
		int value = ParserXML_Metamodel.getEnumElementMCType().getELiteral().size();
		newLiteral.setValue(String.valueOf(value));
		
		ParserXML_Metamodel.getEnumElementMCType().getELiteral().add(newLiteral);
	}
	
	public void selectRelationshipPredefined(String name, ArrayList<String> espec){
		
		//MEANS-END
		if (name.equals("MeansEndLink")) {
			eClassifier newlink = createEclassifier(name, "#//Relationship");
			
			newlink.getEStruct().add(createStructuralFeatureLink("source", "#//IntentionalElement", "1", null));
			newlink.getEStruct().add(createStructuralFeatureLink("target", "#//IntentionalElement", "1", null));
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(createStructuralFeatureLink(name, "#//"+ name, "-1", "true"));
		
		//CONTRIBUTION LINK
		}else if (name.equals("ContributionLink")) {
			eClassifier newlink = createEclassifier(name, "#//Relationship");
			
//			//details
//			details det = new details();
//			det.setKey("name");
//			det.setValue("ContributionType");
//			
//			details det2 = new details();
//			det.setKey("name");
//			det.setValue("ContributionType:Object");
//			
//			details det3 = new details();
//			det.setKey("baseType");
//			det.setValue("ContributionType");
//			
//			//eAnnotation
//			eAnnotation anno = new eAnnotation();
//			anno.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno.getDetails().add(det);
//			
//			eAnnotation anno2 = new eAnnotation();
//			anno2.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno2.getDetails().add(det2);
//			anno2.getDetails().add(det3);
			
			//eClassifier Enum
			eClassifier enumm = new eClassifier();
			enumm.setName("ContributionType");
			enumm.setType("ecore:EEnum");
//			enumm.getEAnnon().add(anno);
			
			if (espec!=null) {
				for (int i = 0; i < espec.size(); i++) {
					if (espec.get(i).equals("make")) {
						enumm.getELiteral().add(createLiteralContributionLink("make", enumm));
					}else if (espec.get(i).equals("break")) {
						enumm.getELiteral().add(createLiteralContributionLink("break", enumm));
					}else if (espec.get(i).equals("unknown")) {
						enumm.getELiteral().add(createLiteralContributionLink("unknown", enumm));
					}else if (espec.get(i).equals("someplus")) {
						enumm.getELiteral().add(createLiteralContributionLink("someplus", enumm));
					}else if (espec.get(i).equals("someminus")) {
						enumm.getELiteral().add(createLiteralContributionLink("someminus", enumm));
					}else if (espec.get(i).equals("and")) {
						enumm.getELiteral().add(createLiteralContributionLink("and", enumm));
					}else if (espec.get(i).equals("or")) {
						enumm.getELiteral().add(createLiteralContributionLink("or", enumm));
					}else if (espec.get(i).equals("help")) {
						enumm.getELiteral().add(createLiteralContributionLink("help", enumm));
					}else if (espec.get(i).equals("hurt")) {
						enumm.getELiteral().add(createLiteralContributionLink("hurt", enumm));
					}
				}
			}
			
//			eClassifier eDataType = new eClassifier();
//			eDataType.setName("ContributionTypeObject");
//			eDataType.setType("ecore:EDataType");
//			eDataType.setInstanceClassName("org.eclipse.emf.common.util.Enumerator");
//			eDataType.getEAnnon().add(anno2);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumm);
//			ParserXML_Metamodel.getPack().getEClass().add(eDataType);
			
			newlink.getEStruct().add(createStructuralFeatureAtributte("name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"));
			newlink.getEStruct().add(createStructuralFeatureAtributte("type", "#//ContributionType"));
			
			newlink.getEStruct().add(createStructuralFeatureLink("source", "#//IntentionalElement", "1", null));
			newlink.getEStruct().add(createStructuralFeatureLink("target", "#//IntentionalElement", "1", null));
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(createStructuralFeatureLink(name, "#//"+ name, "-1", "true"));
		
		//DECOMPOSITION TASK
		}else if (name.equals("TaskDecompositionLink")) {
			eClassifier newlink = createEclassifier(name, "#//Relationship");
			
			newlink.getEStruct().add(createStructuralFeatureLink("source", "#//IntentionalElement", "1", null));
			newlink.getEStruct().add(createStructuralFeatureLink("target", "#//IntentionalElement", "1", null));
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(createStructuralFeatureLink(name, "#//"+ name, "-1", "true"));
		
		//DEPENDENCY LINK
		}else if (name.equals("DependencyLink")) {
			eClassifier newlink = createEclassifier(name, "#//Relationship");
			
//			//details
//			details det = new details();
//			det.setKey("name");
//			det.setValue("DependencyLinkType");
//			
//			details det2 = new details();
//			det.setKey("name");
//			det.setValue("DependencyLinkType:Object");
//			
//			details det3 = new details();
//			det.setKey("baseType");
//			det.setValue("DependencyLinkType");
//			
//			//eAnnotation
//			eAnnotation anno = new eAnnotation();
//			anno.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno.getDetails().add(det);
//			
//			eAnnotation anno2 = new eAnnotation();
//			anno2.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno2.getDetails().add(det2);
//			anno2.getDetails().add(det3);
			
			//eClassifier Enum
			eClassifier enumm = new eClassifier();
			enumm.setName("DependencyLinkType");
			enumm.setType("ecore:EEnum");
//			enumm.getEAnnon().add(anno);
			
			if (espec!=null) {
				for (int i = 0; i < espec.size(); i++) {
					if (espec.get(i).equals("commited")) {
						enumm.getELiteral().add(createLiteralContributionLink("commited", enumm));
					}else if (espec.get(i).equals("open")) {
						enumm.getELiteral().add(createLiteralContributionLink("open", enumm));
					}else if (espec.get(i).equals("critical")) {
						enumm.getELiteral().add(createLiteralContributionLink("critical", enumm));
					}
				}
			}
			
//			eClassifier eDataType = new eClassifier();
//			eDataType.setName("DependencyLinkTypeObject");
//			eDataType.setType("ecore:EDataType");
//			eDataType.setInstanceClassName("org.eclipse.emf.common.util.Enumerator");
//			eDataType.getEAnnon().add(anno2);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumm);
//			ParserXML_Metamodel.getPack().getEClass().add(eDataType);
			
			newlink.getEStruct().add(createStructuralFeatureAtributte("name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"));
			newlink.getEStruct().add(createStructuralFeatureAtributte("type", "#//DependencyLinkType"));
			
			newlink.getEStruct().add(createStructuralFeatureLink("source", "#//NodeObject", "1", null));
			newlink.getEStruct().add(createStructuralFeatureLink("target", "#//NodeObject", "1", null));
			
			ParserXML_Metamodel.getModel().getEStruct().add(createStructuralFeatureLink(name, "#//"+ name, "-1", "true"));
			
		//ActorLink
		}else if (name.equals("ActorLink")) {
			eClassifier newlink = createEclassifier(name, "#//Relationship");
			
//			//details
//			details det = new details();
//			det.setKey("name");
//			det.setValue("ActorLinkType");
//			
//			details det2 = new details();
//			det.setKey("name");
//			det.setValue("ActorLinkType:Object");
//			
//			details det3 = new details();
//			det.setKey("baseType");
//			det.setValue("ActorLinkType");
//			
//			//eAnnotation
//			eAnnotation anno = new eAnnotation();
//			anno.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno.getDetails().add(det);
//			
//			eAnnotation anno2 = new eAnnotation();
//			anno2.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno2.getDetails().add(det2);
//			anno2.getDetails().add(det3);
			
			//eClassifier Enum
			eClassifier enumm = new eClassifier();
			enumm.setName("ActorLinkType");
			enumm.setType("ecore:EEnum");
//			enumm.getEAnnon().add(anno);
			
			if (espec!=null) {
				for (int i = 0; i < espec.size(); i++) {
					if (espec.get(i).equals("isa")) {
						enumm.getELiteral().add(createLiteralContributionLink("isa", enumm));
					}else if (espec.get(i).equals("covers")) {
						enumm.getELiteral().add(createLiteralContributionLink("covers", enumm));
					}else if (espec.get(i).equals("ispartof")) {
						enumm.getELiteral().add(createLiteralContributionLink("ispartof", enumm));
					}else if (espec.get(i).equals("occupies")) {
						enumm.getELiteral().add(createLiteralContributionLink("occupies", enumm));
					}else if (espec.get(i).equals("plays")) {
						enumm.getELiteral().add(createLiteralContributionLink("plays", enumm));
					}else if (espec.get(i).equals("ins")) {
						enumm.getELiteral().add(createLiteralContributionLink("ins", enumm));
					}
				}
			}
			
//			eClassifier eDataType = new eClassifier();
//			eDataType.setName("ActorLinkTypeObject");
//			eDataType.setType("ecore:EDataType");
//			eDataType.setInstanceClassName("org.eclipse.emf.common.util.Enumerator");
//			eDataType.getEAnnon().add(anno2);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumm);
//			ParserXML_Metamodel.getPack().getEClass().add(eDataType);
			
			newlink.getEStruct().add(createStructuralFeatureAtributte("name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"));
			newlink.getEStruct().add(createStructuralFeatureAtributte("type", "#//ActorLinkType"));
			
			newlink.getEStruct().add(createStructuralFeatureLink("source", "#//Compartment", "1", null));
			newlink.getEStruct().add(createStructuralFeatureLink("target", "#//Compartment", "1", null));
			
			ParserXML_Metamodel.getModel().getEStruct().add(createStructuralFeatureLink(name, "#//"+ name, "-1", "true"));
		}
		
	}
	
	private eClassifier createEclassifier(String name, String superType){
		eClassifier newlink = new eClassifier();
		newlink.setName(name.replaceAll(" ", ""));
		newlink.setType("ecore:EClass");
		if (superType!=null) {
			newlink.setSuperType(superType.replaceAll(" ", ""));
		}

		ParserXML_Metamodel.getPack().getEClass().add(newlink);
		
		return newlink;
	}
	
	private eStructuralFeature createStructuralFeatureLink(String name, String eType, String bound, String containment){
		eStructuralFeature aggregation = new eStructuralFeature();
		aggregation.setXsitype("ecore:EReference");
		aggregation.setName(name.replaceAll(" ", "").toLowerCase());
		aggregation.setEtype(eType.replaceAll(" ", ""));
		aggregation.setUpperBound(bound);
		if (containment!=null) {
			aggregation.setContainment("true");
		}
		
		return aggregation;
	}
	
	private eStructuralFeature createStructuralFeatureAtributte(String name, String eType){
		eStructuralFeature atributte = new eStructuralFeature();
		atributte.setXsitype("ecore:EAttribute");
		atributte.setName(name.replaceAll(" ", ""));
		atributte.setUnique("false");
		atributte.setUnsettable("true");
		atributte.setEtype(eType);
		
		return atributte;
	}
	
	private eLiteral createLiteralContributionLink(String name, eClassifier enumm){
		eLiteral newLiteral = new eLiteral();
		newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
		int value = enumm.getELiteral().size();
		newLiteral.setValue(String.valueOf(value));
		
		return newLiteral;
	}

}
