package Injection;

import java.util.ArrayList;
import java.util.StringTokenizer;

import beans.metamodel.details;
import beans.metamodel.eAnnotation;
import beans.metamodel.eClassifier;
import beans.metamodel.eLiteral;
import beans.metamodel.eStructuralFeature;

public class NewConstructor {

	private static ArrayList<eClassifier> eclasses;
	
	private eClassifier newCompartmentModel, newCompartmentCompartment, newCompartmentModelCompartment;
	private eClassifier newElementModel, newElementCompartment, newElementModelCompartment;
	private eClassifier newLinkModel, newLinkCompartment, newLinkModelCompartment;
	
	private static eClassifier elementModel, elementCompartment;
	private static eClassifier enumElementModelType, eDataTypeElementModelType, enumElementCompartmentType, eDataTypeElementCompartmentType;
	
	private static boolean createElementCompartment = false;
	private static boolean createElementModel = false;
	
	public NewConstructor(){
		eclasses = new ArrayList<eClassifier>();
	}
	
	public void setNewElementExist(String name, String composition){
		
		
		if (composition.equals("model")) {
			
			int sizemodel = ParserXML_Metamodel.getPack().getEClass().size();
			
			for (int i = 0; i < sizemodel; i++) {
				if (ParserXML_Metamodel.getPack().getEClass().get(i).getName().equals("ElementModelType")) {
			
				eLiteral newLiteral = new eLiteral();
				newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
				int value = enumElementModelType.getELiteral().size();
				newLiteral.setValue(String.valueOf(value));
				
				enumElementModelType.getELiteral().add(newLiteral);
				
				}
			
			}
		}
		
		if (composition.equals("Compartment")) {
			
			int sizeCompartment = ParserXML_Metamodel.getPack().getEClass().size();
			
			for (int i = 0; i < sizeCompartment; i++) {
				if (ParserXML_Metamodel.getPack().getEClass().get(i).getName().equals("ElementCompartmentType")) {
					
					//NewLiteral
					eLiteral newLiteral = new eLiteral();
					newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
					int value = ParserXML_Metamodel.getPack().getEClass().get(i).getELiteral().size();
					newLiteral.setValue(String.valueOf(value));
					
					ParserXML_Metamodel.getPack().getEClass().get(i).getELiteral().add(newLiteral);
				}
			}
		}
	}
	
	public void setNewCompartmentExist(String name, String composition){
		
		if (composition.equals("Compartment") || composition.equals("modelCompartment")) {

			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = ParserXML_Metamodel.getEnumCompartmentType().getELiteral().size();
			newLiteral.setValue(String.valueOf(value));

			ParserXML_Metamodel.getEnumCompartmentType().getELiteral().add(newLiteral);
			
		}
	}
	
	//SEM ATRIBUTOS
	public void setNewElementIntencional(String name, String composition){
		
		if (composition.equals("model")) {
			
			//ENUMELEMENTMODEL
			//details
			details detElementModelType = new details();
			detElementModelType.setKey("name");
			detElementModelType.setValue("ElementModelType");
			
			details detDataTypeElementModelType1 = new details();
			detDataTypeElementModelType1.setKey("name");
			detDataTypeElementModelType1.setValue("ElementModelType:Object");
			
			details detDataTypeElementModelType2 = new details();
			detDataTypeElementModelType2.setKey("baseType");
			detDataTypeElementModelType2.setValue("ElementModelType");
			
			
			//ENUMELEMENTMODEL
			//eClassifier
			enumElementModelType = new eClassifier();
			enumElementModelType.setName("ElementModelType");
			enumElementModelType.setType("ecore:EEnum");
			
			//ELEMENTMODEL
			//eStructuralFeatures
			eStructuralFeature atNameElementModel = new eStructuralFeature();
			atNameElementModel.setXsitype("ecore:EAttribute");
			atNameElementModel.setName("type");
			atNameElementModel.setEtype("#//ElementModelType");
			
			//ELEMENTMODEL
			//eClassifier
			elementModel = new eClassifier();
			elementModel.setName("ElementModel");
			elementModel.setType("ecore:EClass");
			elementModel.setSuperType("#//IntentionalElement");
			elementModel.getEStruct().add(atNameElementModel);
			
			ParserXML_Metamodel.getPack().getEClass().add(elementModel);
			
			eStructuralFeature refElementModel = new eStructuralFeature();
			refElementModel.setXsitype("ecore:EReference");
			refElementModel.setName("elementsmodel");
			refElementModel.setEtype("#//ElementModel");
			refElementModel.setUpperBound("-1");
			refElementModel.setContainment("true");
			
			ParserXML_Metamodel.getModel().getEStruct().add(refElementModel);
			
			//NewLiteral
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = enumElementModelType.getELiteral().size();
			newLiteral.setValue(String.valueOf(value));
			
			enumElementModelType.getELiteral().add(newLiteral);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumElementModelType);
			
		}else if (composition.equals("Compartment")) {

			//ENUMELEMENTCompartment
			//details
			details detElementCompartmentType = new details();
			detElementCompartmentType.setKey("name");
			detElementCompartmentType.setValue("ElementCompartmentType");
			
			details detDataTypeElementCompartmentType1 = new details();
			detDataTypeElementCompartmentType1.setKey("name");
			detDataTypeElementCompartmentType1.setValue("ElementCompartmentType:Object");
			
			details detDataTypeElementCompartmentType2 = new details();
			detDataTypeElementCompartmentType2.setKey("baseType");
			detDataTypeElementCompartmentType2.setValue("ElementCompartmentType");
			
			
			//ENUMELEMENTCompartment
			//eClassifier
			enumElementCompartmentType = new eClassifier();
			enumElementCompartmentType.setName("ElementCompartmentType");
			enumElementCompartmentType.setType("ecore:EEnum");
			
			//ELEMENTCompartment
			//eStructuralFeatures
			eStructuralFeature atNameElementCompartment = new eStructuralFeature();
			atNameElementCompartment.setXsitype("ecore:EAttribute");
			atNameElementCompartment.setName("type");
			atNameElementCompartment.setEtype("#//ElementCompartmentType");
			
			//ELEMENTCompartment
			//eClassifier
			elementCompartment = new eClassifier();
			elementCompartment.setName("ElementCompartment");
			elementCompartment.setType("ecore:EClass");
			elementCompartment.setSuperType("#//IntentionalElement");
			elementCompartment.getEStruct().add(atNameElementCompartment);
			
			ParserXML_Metamodel.getPack().getEClass().add(elementCompartment);
			
			eStructuralFeature refElementCompartmentCompartment = new eStructuralFeature();
			refElementCompartmentCompartment.setXsitype("ecore:EReference");
			refElementCompartmentCompartment.setName("elementsCompartment");
			refElementCompartmentCompartment.setEtype("#//ElementCompartment");
			refElementCompartmentCompartment.setUpperBound("-1");
			refElementCompartmentCompartment.setContainment("true");
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(refElementCompartmentCompartment);
			
			//NewLiteral
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = enumElementCompartmentType.getELiteral().size();
			newLiteral.setValue(String.valueOf(value));
			
			enumElementCompartmentType.getELiteral().add(newLiteral);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumElementCompartmentType);
			
		}else if (composition.equals("modelCompartment")) {
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = ParserXML_Metamodel.getEnumElementMCType().getELiteral().size();
			newLiteral.setValue(String.valueOf(value));

			ParserXML_Metamodel.getEnumElementMCType().getELiteral().add(newLiteral);
		}
	}
	
	//SEM ATRIBUTOS
	public void setNewElementNode(String name, String composition){
		
		if (composition.equals("model")) {
			
			//ENUMELEMENTMODEL
			//details
			details detElementModelType = new details();
			detElementModelType.setKey("name");
			detElementModelType.setValue("ElementModelType");
			
			details detDataTypeElementModelType1 = new details();
			detDataTypeElementModelType1.setKey("name");
			detDataTypeElementModelType1.setValue("ElementModelType:Object");
			
			details detDataTypeElementModelType2 = new details();
			detDataTypeElementModelType2.setKey("baseType");
			detDataTypeElementModelType2.setValue("ElementModelType");
			
			
			//ENUMELEMENTMODEL
			//eClassifier
			enumElementModelType = new eClassifier();
			enumElementModelType.setName("ElementModelType");
			enumElementModelType.setType("ecore:EEnum");
//			enumElementModelType.getEAnnon().add(annoElementModelType);
			
			//ELEMENTMODEL
			//eStructuralFeatures
			eStructuralFeature atNameElementModel = new eStructuralFeature();
			atNameElementModel.setXsitype("ecore:EAttribute");
			atNameElementModel.setName("type");
			atNameElementModel.setEtype("#//ElementModelType");
			
			//ELEMENTMODEL
			//eClassifier
			elementModel = new eClassifier();
			elementModel.setName("ElementModel");
			elementModel.setType("ecore:EClass");
			elementModel.setSuperType("#//NodeObject");
			elementModel.getEStruct().add(atNameElementModel);
			
			ParserXML_Metamodel.getPack().getEClass().add(elementModel);
			
			eStructuralFeature refElementModel = new eStructuralFeature();
			refElementModel.setXsitype("ecore:EReference");
			refElementModel.setName("elementsmodel");
			refElementModel.setEtype("#//ElementModel");
			refElementModel.setUpperBound("-1");
			refElementModel.setContainment("true");
			
			ParserXML_Metamodel.getModel().getEStruct().add(refElementModel);
			
			//NewLiteral
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = enumElementModelType.getELiteral().size();
			newLiteral.setValue(String.valueOf(value));
			
			enumElementModelType.getELiteral().add(newLiteral);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumElementModelType);
			
		}else if (composition.equals("Compartment")) {

			//ENUMELEMENTCompartment
			//details
			details detElementCompartmentType = new details();
			detElementCompartmentType.setKey("name");
			detElementCompartmentType.setValue("ElementCompartmentType");
			
			details detDataTypeElementCompartmentType1 = new details();
			detDataTypeElementCompartmentType1.setKey("name");
			detDataTypeElementCompartmentType1.setValue("ElementCompartmentType:Object");
			
			details detDataTypeElementCompartmentType2 = new details();
			detDataTypeElementCompartmentType2.setKey("baseType");
			detDataTypeElementCompartmentType2.setValue("ElementCompartmentType");
			
			//ENUMELEMENTCompartment
			//eClassifier
			enumElementCompartmentType = new eClassifier();
			enumElementCompartmentType.setName("ElementCompartmentType");
			enumElementCompartmentType.setType("ecore:EEnum");
//			enumElementCompartmentType.getEAnnon().add(annoElementCompartmentType);
			
			//ELEMENTCompartment
			//eStructuralFeatures
			eStructuralFeature atNameElementCompartment = new eStructuralFeature();
			atNameElementCompartment.setXsitype("ecore:EAttribute");
			atNameElementCompartment.setName("type");
			atNameElementCompartment.setEtype("#//ElementCompartmentType");
			
			//ELEMENTCompartment
			//eClassifier
			elementCompartment = new eClassifier();
			elementCompartment.setName("ElementCompartment");
			elementCompartment.setType("ecore:EClass");
			elementCompartment.setSuperType("#//NodeObject");
			elementCompartment.getEStruct().add(atNameElementCompartment);
			
			ParserXML_Metamodel.getPack().getEClass().add(elementCompartment);
			
			eStructuralFeature refElementCompartmentCompartment = new eStructuralFeature();
			refElementCompartmentCompartment.setXsitype("ecore:EReference");
			refElementCompartmentCompartment.setName("elementsCompartment");
			refElementCompartmentCompartment.setEtype("#//ElementCompartment");
			refElementCompartmentCompartment.setUpperBound("-1");
			refElementCompartmentCompartment.setContainment("true");
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(refElementCompartmentCompartment);
			
			//NewLiteral
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = enumElementCompartmentType.getELiteral().size();
			newLiteral.setValue(String.valueOf(value));
			
			enumElementCompartmentType.getELiteral().add(newLiteral);
			
			ParserXML_Metamodel.getPack().getEClass().add(enumElementCompartmentType);
			
		}else if (composition.equals("modelCompartment")) {
			//fazer XXX
		}
	}
	
	public void setNewLink(String name, String composition, String cardinality){
		
		if (composition.equals("model")) {
			newLinkModel = createEclassifier(name, null);
			newLinkModel.setSuperType("#//Relationship");
			createAtributte(name, "name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString", null);
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, cardinality, "true"));
			
		}else if (composition.equals("Compartment")) {
			newLinkCompartment = createEclassifier(name, null);
			newLinkCompartment.setSuperType("#//Relationship");
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, cardinality, "true"));
			createAtributte(name, "name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString", null);
			
		}else if (composition.equals("modelCompartment")) {
			newLinkModelCompartment = createEclassifier(name, null);
			newLinkModelCompartment.setSuperType("#//Relationship");
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, cardinality, "true"));
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, cardinality, "true"));
			createAtributte(name, "name", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString", null);
		}
		
	}

	public void setNewCompartment(String name, String composition){
		if (composition.equals("model")) {
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = ParserXML_Metamodel.getEnumCompartmentType().getELiteral().size();
			newLiteral.setValue(String.valueOf(value));

			ParserXML_Metamodel.getEnumCompartmentType().getELiteral().add(newLiteral);
			
		}else if (composition.equals("Compartment") || composition.equals("modelCompartment")) {
			eLiteral newLiteral = new eLiteral();
			newLiteral.setName(name.replaceAll(" ", "").toUpperCase());
			int value = ParserXML_Metamodel.getEnumCompartmentType().getELiteral().size();
			newLiteral.setValue(String.valueOf(value));

			ParserXML_Metamodel.getEnumCompartmentType().getELiteral().add(newLiteral);
			
			eStructuralFeature autoRelationship = new eStructuralFeature();
			autoRelationship.setXsitype("ecore:EReference");
			autoRelationship.setName(("m2m"+name).toLowerCase());
			autoRelationship.setEtype("#//Compartment");
			autoRelationship.setUpperBound("-1");
			autoRelationship.setContainment("true");
			
			ParserXML_Metamodel.getCompartment().getEStruct().add(autoRelationship);
			
		}
	}
	
	//SEM ATRIBUTOS
	public void setElementAttribute(String name, String composition){
		if (composition.equals("model")) {
			newElementModel = createEclassifier(name, null);
			newElementModel.setSuperType("#//ElementModel");
			
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			
		}else if (composition.equals("Compartment")) {
			newElementCompartment = createEclassifier(name, null);
			newElementCompartment.setSuperType("#//ElementCompartment");
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			
		}else if (composition.equals("modelCompartment")) {
			newElementModelCompartment = createEclassifier(name, null);
			newElementModelCompartment.setSuperType("#//ElementMC");
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
		}
	}
	
	public void setCompartmentAttribute(String name, String composition){
		if (composition.equals("model")) {
			newCompartmentModel = createEclassifier(name, null);
			newCompartmentModel.setSuperType("#//Compartment");
			
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			
		}else if (composition.equals("Compartment")) {
			newCompartmentCompartment = createEclassifier(name, null);
			newCompartmentCompartment.setSuperType("#//Compartment");
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			
		}else if (composition.equals("modelCompartment")) {
			newCompartmentModelCompartment = createEclassifier(name, null);
			newCompartmentModelCompartment.setSuperType("#//Compartment");
			ParserXML_Metamodel.getModel().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
			ParserXML_Metamodel.getCompartment().getEStruct().add(createLink(name, "#//"+ name, "-1", "true"));
		}
	}
	
	
	private eClassifier createEclassifier(String name, String superType){
		eClassifier newConstructor = new eClassifier();
		newConstructor.setName(name.replaceAll(" ", ""));
		newConstructor.setType("ecore:EClass");
		if (superType!=null) {
			newConstructor.setSuperType(superType);
		}

		ParserXML_Metamodel.getPack().getEClass().add(newConstructor);
		
		return newConstructor;
	}
	
	public void createSource(String eclass, String name, String eType, String containment){
		eStructuralFeature source = new eStructuralFeature();
		source.setXsitype("ecore:EReference");
		source.setName(name.replaceAll(" ", "").toLowerCase());
		if (eType.equals("Link")) {
			source.setEtype("#//Relationship");
		}else{
			source.setEtype("#//" + eType.replaceAll(" ", ""));
		}
		source.setUpperBound("1");
		source.setContainment(containment);
		
		for (int i = 0; i < ParserXML_Metamodel.getPack().getEClass().size(); i++) {
			if (ParserXML_Metamodel.getPack().getEClass().get(i).getName().equals(eclass.replaceAll(" ", ""))) {
				ParserXML_Metamodel.getPack().getEClass().get(i).getEStruct().add(source);
			}
		}
	}
	
	public void createTarget(String eclass, String name, String eType, String containment){
		eStructuralFeature target = new eStructuralFeature();
		target.setXsitype("ecore:EReference");
		target.setName(name.replaceAll(" ", "").toLowerCase());
		if (eType.equals("Link")) {
			target.setEtype("#//Relationship");
		}else{
			target.setEtype("#//" + eType.replaceAll(" ", ""));
		}
		target.setUpperBound("1");
		target.setContainment(containment);
		
		for (int i = 0; i < ParserXML_Metamodel.getPack().getEClass().size(); i++) {
			if (ParserXML_Metamodel.getPack().getEClass().get(i).getName().equals(eclass.replaceAll(" ", ""))) {
				ParserXML_Metamodel.getPack().getEClass().get(i).getEStruct().add(target);
			}
		}
	}
	
	private eStructuralFeature createLink(String name, String eType, String bound, String containment){
		eStructuralFeature composition = new eStructuralFeature();
		composition.setXsitype("ecore:EReference");
		composition.setName(name.replaceAll(" ", "").toLowerCase());
		composition.setEtype(eType.replaceAll(" ", ""));
		composition.setUpperBound(bound);
		composition.setContainment(containment);
		
		return composition;
	}
	
	public void createAtributte(String eclass, String name, String eType, ArrayList<eLiteral> literals){
		eStructuralFeature attribute = new eStructuralFeature();
		attribute.setXsitype("ecore:EAttribute");
		attribute.setName(name.replaceAll(" ", ""));
		attribute.setUnique("false");
		attribute.setUnsettable("true");
		String ec = name.replaceAll(" ", "");
		if (eType.contains("ecore:EDataType")) {
			attribute.setEtype(eType);
		}else{
			//details
			details det = new details();
			det.setKey("name");
			det.setValue(ec + "Type");
			
			details det2 = new details();
			det.setKey("name");
			det.setValue(ec + "Type:Object");
			
			details det3 = new details();
			det.setKey("baseType");
			det.setValue(ec + "Type");
			
			//eAnnotation
			eAnnotation anno = new eAnnotation();
			anno.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno.getDetails().add(det);
			
			eAnnotation anno2 = new eAnnotation();
			anno2.setSource("http:///org/eclipse/emf/ecore/util/ExtendedMetaData");
//			anno2.getDetails().add(det2);
//			anno2.getDetails().add(det3);
			
			//eClassifier Enum
			eClassifier enumm = new eClassifier();
			enumm.setName(ec + "Type");
			enumm.setType("ecore:EEnum");
//			enumm.getEAnnon().add(anno);
			
			eClassifier eDataType = new eClassifier();
			eDataType.setName(ec+ "TypeObject");
			eDataType.setType("ecore:EDataType");
			eDataType.setInstanceClassName("org.eclipse.emf.common.util.Enumerator");
//			eDataType.getEAnnon().add(anno2);
			
			if (literals!=null) {
				for (int i = 0; i < literals.size(); i++) {
					eLiteral newLiteral = new eLiteral();
					newLiteral.setLiteral(literals.get(i).getLiteral().replaceAll(" ", "").toUpperCase());
					newLiteral.setName((name+literals.get(i).getLiteral()).replaceAll(" ", "").toUpperCase());
					int value = enumm.getELiteral().size();
					newLiteral.setValue(String.valueOf(value));

					enumm.getELiteral().add(newLiteral);
				}
			}
			
			ParserXML_Metamodel.getPack().getEClass().add(enumm);
//			ParserXML_Metamodel.getPack().getEClass().add(eDataType);
			
			attribute.setEtype("#//" + enumm.getName());
		}
		
		for (int i = 0; i < ParserXML_Metamodel.getPack().getEClass().size(); i++) {
			if (ParserXML_Metamodel.getPack().getEClass().get(i).getName().equals(eclass.replaceAll(" ", ""))) {
				ParserXML_Metamodel.getPack().getEClass().get(i).getEStruct().add(attribute);
			}
		}
	}

	public static boolean isCreateElementCompartment() {
		return createElementCompartment;
	}

	public static void setCreateElementCompartment(
			boolean createElementCompartment) {
		NewConstructor.createElementCompartment = createElementCompartment;
	}

	public static boolean isCreateElementModel() {
		return createElementModel;
	}

	public static void setCreateElementModel(boolean createElementModel) {
		NewConstructor.createElementModel = createElementModel;
	}
	
}
