package beans.metamodel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import com.thoughtworks.xstream.XStream;

public class eClassifier implements Serializable{

	private String type;
	private String name;
	private String instanceClassName;
	private String superType;
	private ArrayList<eStructuralFeature> eStruct;
	private ArrayList<eAnnotation> eAnnon;
	private ArrayList<eLiteral> eLiteral;

	public eClassifier() {
		super();
		eStruct = new ArrayList<eStructuralFeature>();
		eAnnon = new ArrayList<eAnnotation>();
		eLiteral = new ArrayList<eLiteral>();
	}

	public String getInstanceClassName() {
		return instanceClassName;
	}

	public void setInstanceClassName(String instanceClassName) {
		this.instanceClassName = instanceClassName;
	}

	public String getName() {
		return name;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getSuperType() {
		return superType;
	}

	public void setSuperType(String superType) {
		this.superType = superType;
	}

	public ArrayList<eStructuralFeature> getEStruct() {
		return eStruct;
	}

	public void setEStruct(ArrayList<eStructuralFeature> struct) {
		eStruct = struct;
	}

	public ArrayList<eAnnotation> getEAnnon() {
		return eAnnon;
	}

	public void setEAnnon(ArrayList<eAnnotation> annon) {
		eAnnon = annon;
	}

	public ArrayList<eLiteral> getELiteral() {
		return eLiteral;
	}

	public void setELiteral(ArrayList<eLiteral> literal) {
		eLiteral = literal;
	}
	
	

}
