package beans.metamodel;

import java.util.ArrayList;

public class Constructor {
	
	private String name;
	private String classification;
	private String composition;
	private boolean compartment;
	private String cardinality;
	private String source;
	private String target;
	private ArrayList<Attribute> attributes;
	
	public Constructor(){
		attributes = new ArrayList<Attribute>();
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getClassification() {
		return classification;
	}

	public void setClassification(String classification) {
		this.classification = classification;
	}

	public String getComposition() {
		return composition;
	}

	public void setComposition(String composition) {
		this.composition = composition;
	}

	public boolean isCompartment() {
		return compartment;
	}

	public void setCompartment(boolean compartment) {
		this.compartment = compartment;
	}

	public String getCardinality() {
		return cardinality;
	}

	public void setCardinality(String cardinality) {
		this.cardinality = cardinality;
	}

	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public String getTarget() {
		return target;
	}

	public void setTarget(String target) {
		this.target = target;
	}

	public ArrayList<Attribute> getAttributes() {
		return attributes;
	}

	public void setAttributes(ArrayList<Attribute> attributes) {
		this.attributes = attributes;
	}

}
